"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const Config = require('../../config');
const fs = require('fs-extra-promise');
const path = require('path');
const uglify = require('uglify-js');
function publishToEgretLibs(env) {
    return __awaiter(this, void 0, void 0, function* () {
        let folder = yield Config.getConfig("egret-libs-folder");
        console.log(env.egretProjectPath);
        console.log(folder);
        let packageJson = yield fs.readJSONAsync(path.join(env.egretProjectPath, "package.json"));
        let targetPath = path.join(folder, packageJson.name, packageJson.version);
        let fromPath = path.join(env.egretProjectPath, "bin", packageJson.name);
        let s = path.join(fromPath, packageJson.name + ".js");
        let t = path.join(fromPath, packageJson.name + ".min.js");
        yield minify(s, t);
        yield fs.copyAsync(fromPath, targetPath);
        console.log(fromPath, targetPath);
    });
}
exports.publishToEgretLibs = publishToEgretLibs;
function minify(sourcefile, filename) {
    return __awaiter(this, void 0, void 0, function* () {
        let defines = {
            DEBUG: false,
            RELEASE: true
        };
        let options = { compress: { global_defs: defines } };
        let result = uglify.minify(sourcefile, options);
        yield fs.writeFileAsync(filename, result.code, 'utf-8');
    });
}
//# sourceMappingURL=index.js.map