"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const file = require("./src/file");
const path = require("path");
// import euiParser = require("./parser");
const CONFIG = require("./src/config");
const exml_service = require("./src/exml-service/componentScanner");
const themeParser = require("./src/themeParser");
const exmlParser = require("./src/eui/parser/EXMLParser");
const stream = require('stream');
var parser = new exmlParser.EXMLParser();
class Transform extends stream.Transform {
    _transform(chunk, encoding, callback) {
        console.log("transform", chunk);
        this.push(chunk);
        callback();
    }
}
let hook = {
    filter: (env) => __awaiter(this, void 0, void 0, function* () {
        return themeParser.themeFilter(env.filePath);
    }),
    execute: (env) => __awaiter(this, void 0, void 0, function* () {
        let content = env.content.toString();
        let result = yield filterThemeJsonFile({ path: env.filePath, content: content, projectPath: env.sourceRoot });
        console.log("result", result);
        return new Buffer(result);
    })
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = hook;
function filterThemeJsonFile(args) {
    return __awaiter(this, void 0, Promise, function* () {
        if (themeParser.themeFilter(args.path)) {
            CONFIG.setDir(path.join(__dirname, "../../../"));
            CONFIG.isClean = false;
            CONFIG.setProjectDir(args.projectPath);
            let themeObj = JSON.parse(args.content);
            let config = yield exml_service.run(CONFIG.getProjectDir());
            console.log(`config generated!`);
            CONFIG.set(config);
            themeObj.exmls.forEach(exmlItem => {
                console.log("parsing:", exmlItem.path);
                exmlItem.gjs = parser.parse(exmlItem.content);
                //测试用
                // if(
                //     // exmlItem.path.indexOf("TPanel.exml")!==-1 ||
                //     exmlItem.path.indexOf("SendToDesktopAlertSkin.exml")!==-1
                // ){
                //     console.log(exmlItem.gjs);
                // }
                exmlItem.className = parser.className;
                delete exmlItem.content;
            });
            let themeTxt = JSON.stringify(themeObj, null, 4);
            // console.log("themeTxt:",themeTxt);
            file.save(args.path, themeTxt);
            return themeTxt;
        }
        else {
            return args.content;
        }
    });
}
//# sourceMappingURL=index.js.map