"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const fs = require('fs-extra-promise');
const path = require('path');
let hook = { name: "generateHtmlFile", execute: null };
hook.execute = function (env) {
    return __awaiter(this, void 0, void 0, function* () {
        let htmlFilePath = path.join(env.root, 'index.html');
        let outputPath = path.join(env.releaseFolder, 'index.html');
        let content = yield fs.readFileAsync(htmlFilePath, "utf-8");
        content = replaceHTMLContent(content);
        yield fs.writeFileAsync(outputPath, content);
        yield copyLib(content);
        yield cp("resource");
        function copyLib(content) {
            return __awaiter(this, void 0, void 0, function* () {
                let reg2 = /src\=\"[^>]*\"/g;
                let libs = content.match(reg2).map(item => {
                    let from = 'src=\"'.length;
                    let to = item.length - '\"'.length;
                    return item.substring(from, to);
                });
                yield Promise.all(libs.map(lib => cp(lib)));
            });
        }
        function cp(file) {
            return __awaiter(this, void 0, void 0, function* () {
                if (yield fs.existsAsync(file)) {
                    yield fs.copyAsync(path.join(env.root, file), path.join(env.releaseFolder, file));
                }
            });
        }
        function replaceHTMLContent(content) {
            //替换使用 html 中的 src-release 目录
            var reg = /src[^>]*src-release/g;
            let result = content = content.replace(reg, "src");
            //替换 game_files 脚本
            var reg = /<!--(\s)*game_files_start(\s)*-->[\s\S]*<!--(\s)*game_files_end(\s)*-->/;
            var replaceStr = '<!--game_files_start-->\n' + '\t<script src="main.min.js"></script>\n' + '\t<!--game_files_end-->';
            content = content.replace(reg, replaceStr);
            return content;
        }
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = hook;
//# sourceMappingURL=generate-html.js.map