"use strict";
var Resource;
(function (Resource) {
    var ResourceNodeType;
    (function (ResourceNodeType) {
        ResourceNodeType[ResourceNodeType["FILE"] = 0] = "FILE";
        ResourceNodeType[ResourceNodeType["DICTIONARY"] = 1] = "DICTIONARY";
    })(ResourceNodeType || (ResourceNodeType = {}));
    function getResourceInfo(url) {
        return ResourceConfig.getFile(url);
    }
    Resource.getResourceInfo = getResourceInfo;
    function print() {
        console.log(Resource.data);
    }
    Resource.print = print;
    var ResourceConfig;
    (function (ResourceConfig) {
        ResourceConfig.data = {};
        function addFile(filename, type) {
            if (!type)
                type = "";
            filename = normalize(filename);
            let basefilename = basename(filename);
            let folder = dirname(filename);
            if (!exists(folder)) {
                mkdir(folder);
            }
            let d = reslove(folder);
            d[basefilename] = { url: filename, type: type };
        }
        ResourceConfig.addFile = addFile;
        function getFile(filename) {
            return reslove(filename);
        }
        ResourceConfig.getFile = getFile;
        function basename(filename) {
            return filename.substr(filename.lastIndexOf("/") + 1);
        }
        function normalize(filename) {
            return filename.split("/").filter(d => !!d).join("/");
        }
        function dirname(path) {
            return path.substr(0, path.lastIndexOf("/"));
        }
        function reslove(dirpath) {
            dirpath = normalize(dirpath);
            let list = dirpath.split("/");
            let current = ResourceConfig.data;
            for (let f of list) {
                current = current[f];
            }
            return current;
        }
        function mkdir(dirpath) {
            dirpath = normalize(dirpath);
            let list = dirpath.split("/");
            let current = ResourceConfig.data;
            for (let f of list) {
                if (!current[f]) {
                    current[f] = {};
                }
                current = current[f];
            }
        }
        ResourceConfig.mkdir = mkdir;
        function exists(dirpath) {
            dirpath = normalize(dirpath);
            let list = dirpath.split("/");
            let current = ResourceConfig.data;
            for (let f of list) {
                if (!current[f]) {
                    return false;
                }
                current = current[f];
            }
            return true;
        }
        ResourceConfig.exists = exists;
    })(ResourceConfig = Resource.ResourceConfig || (Resource.ResourceConfig = {}));
})(Resource = exports.Resource || (exports.Resource = {}));
//# sourceMappingURL=resource.js.map