import * as _config from './config';
export declare var config: typeof _config;
export interface File {
    url: string;
    type: string;
    name?: string;
}
export interface Dictionary {
    [file: string]: File | Dictionary;
}
export interface Data {
    filter?: (file: any, env: any, plugins: any) => Promise<File>;
    resources: Dictionary;
    groups?: {
        [groupName: string]: string[];
    };
    alias?: {
        [aliasName: string]: string;
    };
}
export declare var data: Data;
export declare function print(): void;
export declare namespace ResourceConfig {
    var config: Data;
    function addFile(r: any): void;
    function getFile(filename: string): File;
    function init(filename: any): Promise<void>;
}
export declare function build(p: string, target?: string): Promise<void>;
