"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const fs = require('fs-extra-promise');
const _config = require('./config');
const _build = require('./build');
exports.config = _config;
var ResourceNodeType;
(function (ResourceNodeType) {
    ResourceNodeType[ResourceNodeType["FILE"] = 0] = "FILE";
    ResourceNodeType[ResourceNodeType["DICTIONARY"] = 1] = "DICTIONARY";
})(ResourceNodeType || (ResourceNodeType = {}));
// export function getResourceInfo(url: string): File {
//     return ResourceConfig.getFile(url);
// }
function print() {
    console.log(exports.data);
}
exports.print = print;
var ResourceConfig;
(function (ResourceConfig) {
    function addFile(r) {
        filesystem.addFile(r);
    }
    ResourceConfig.addFile = addFile;
    function getFile(filename) {
        return filesystem.getFile(filename);
    }
    ResourceConfig.getFile = getFile;
    function init(filename) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!fs.existsSync(filename)) {
                console.log(filename);
                yield createResourceConfigFile(filename);
            }
            let data = require(filename);
            filesystem.data = data.resources;
            ResourceConfig.config = data;
        });
    }
    ResourceConfig.init = init;
    function createResourceConfigFile(filename) {
        return __awaiter(this, void 0, void 0, function* () {
            let obj = {
                groups: {},
                alias: {},
                resources: {}
            };
            let content = `exports.groups = ${JSON.stringify(obj.groups, null, "\t")};
exports.alias = ${JSON.stringify(obj.alias, null, "\t")};
exports.getTypeByFileExtensionName = function(ext) {
    var type;
    switch (ext) {
        case "png":
        case "jpg":
            type = "image";
            break;
        case "fnt":
            type = "font";
            break;
        case "mp3":
            type = "sound";
            break;
        case "pvr":
            type = "pvr";
            break;
    }
    return type;
}
exports.filter = function(file, env, plugins) {

    return new Promise((reslove, reject) => {
        var type;
        var doNotExportType = true;
        var ext = file.ext;
        var p = file.path;
        //console.log(file)
        type = exports.getTypeByFileExtensionName(ext);
        if (!type) {
            switch (ext) {
                case "json":
                    if (p.indexOf("sheet") >= 0) {
                        type = "sheet";
                    } else if (p.indexOf("movieclip") >= 0) {
                        type = "movieclip";
                    } else {
                        type = "json";
                    }
                    break;
            }
            doNotExportType = false;
        }
        if (type) {

                var url = p;//plugins.crc32(p) + "." + ext;
                //console.log(url)
                // plugins.add(url)
                if (doNotExportType) {
                    type = ""
                }
                plugins.add({ url, type, name: p })
                reslove();
                // reslove({ url, type });
    
        }
        else {
            reslove(null);
        }
    });
}
exports.resources = ${JSON.stringify(obj.resources, null, "\t")};`;
            yield fs.writeFileAsync(filename, content);
        });
    }
    var filesystem;
    (function (filesystem) {
        filesystem.data = {};
        function addFile(r) {
            var type = r.type;
            var filename = r.name;
            var url = r.url;
            if (!type)
                type = "";
            filename = normalize(filename);
            let basefilename = basename(filename);
            let folder = dirname(filename);
            if (!exists(folder)) {
                mkdir(folder);
            }
            let d = reslove(folder);
            if (!type) {
                d[basefilename] = url;
            }
            else {
                d[basefilename] = { url: url, type: type };
            }
        }
        filesystem.addFile = addFile;
        function getFile(filename) {
            return reslove(filename);
        }
        filesystem.getFile = getFile;
        function basename(filename) {
            return filename.substr(filename.lastIndexOf("/") + 1);
        }
        function normalize(filename) {
            return filename.split("/").filter(d => !!d).join("/");
        }
        function dirname(path) {
            return path.substr(0, path.lastIndexOf("/"));
        }
        function reslove(dirpath) {
            dirpath = normalize(dirpath);
            let list = dirpath.split("/");
            let current = filesystem.data;
            for (let f of list) {
                current = current[f];
            }
            return current;
        }
        function mkdir(dirpath) {
            dirpath = normalize(dirpath);
            let list = dirpath.split("/");
            let current = filesystem.data;
            for (let f of list) {
                if (!current[f]) {
                    current[f] = {};
                }
                current = current[f];
            }
        }
        filesystem.mkdir = mkdir;
        function exists(dirpath) {
            dirpath = normalize(dirpath);
            let list = dirpath.split("/");
            let current = filesystem.data;
            for (let f of list) {
                if (!current[f]) {
                    return false;
                }
                current = current[f];
            }
            return true;
        }
        filesystem.exists = exists;
    })(filesystem || (filesystem = {}));
})(ResourceConfig = exports.ResourceConfig || (exports.ResourceConfig = {}));
function build(p, target) {
    return __awaiter(this, void 0, void 0, function* () {
        return _build.build(p, target);
    });
}
exports.build = build;
//# sourceMappingURL=index.js.map