export declare function parseFromPreviousVersion(lastVersionData: any): void;
export interface File {
    url: string;
    type: string;
    crc32?: string;
    size?: number;
}
export interface Dictionary {
    [file: string]: File | Dictionary;
}
export interface Data {
    resources: Dictionary;
    groups?: {
        [groupName: string]: string[];
    };
    alias?: {
        [aliasName: string]: string;
    };
}
export declare var data: Data;
export declare function getResourceInfo(url: string): File;
export declare function print(): void;
export declare namespace ResourceConfig {
    var data: Dictionary;
    function addFile(filename: string, type?: string): void;
    function getFile(filename: string): File;
    function mkdir(dirpath: string): void;
    function exists(dirpath: string): boolean;
}
export declare function run(projectRoot: string): Promise<void>;
