"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const egret_project = require('../egret-project');
const Config = require('../Config');
const path = require('path');
const fs = require('fs-extra-promise');
function run(env) {
    return __awaiter(this, void 0, void 0, function* () {
        function copyLibrary() {
            return __awaiter(this, void 0, void 0, function* () {
                let folder = yield Config.getConfig("egret-libs-folder");
                let source = path.join(folder, "resourcemanager", "bin");
                let target = path.join(env.egretProjectPath, "bin");
                yield fs.copyAsync(source, target);
            });
        }
        function convertEgretProperties() {
            return __awaiter(this, void 0, void 0, function* () {
                let propertyData = yield egret_project.getEgretProjectConfig(env);
                delete propertyData.modules['res'];
                for (let m of propertyData.modules) {
                    if (m.name == "res") {
                        m.name = "resourcemanager";
                        m.path = ".";
                    }
                }
                yield egret_project.updateProjectConfig(env);
            });
        }
        yield convertEgretProperties();
        yield copyLibrary();
    });
}
exports.run = run;
//# sourceMappingURL=upgrade.js.map