"use strict";
const fs_1 = require("fs");
const ts = require("typescript");
function delint(sourceFile) {
    findClass(sourceFile);
    function findClass(node) {
        ts.SyntaxKind.ClassExpression;
        if (node.kind == ts.SyntaxKind.ClassDeclaration) {
            var classNode = node;
            // console.log(classNode.name.text);
            // findProperties(node);
            ts.forEachChild(node, findProperties);
        }
        else {
            ts.forEachChild(node, findClass);
        }
    }
    function findProperties(node) {
        if (node.kind == ts.SyntaxKind.PropertyDeclaration) {
            console.log("====");
            // console.log (node.name);
            var propertyNode = node;
            console.log("====");
            console.log(propertyNode);
        }
        else {
            ts.forEachChild(node, findProperties);
        }
    }
    function isPublic(node) {
        var list = node.modifiers;
        console.log(node.modifiers);
    }
    function report(node, message) {
        var result = sourceFile.getLineAndCharacterOfPosition(node.getStart());
        let line = result.line;
        let character = result.character;
        console.log(`${sourceFile.fileName} (${line + 1},${character + 1}): ${message}`);
    }
}
exports.delint = delint;
const fileNames = process.argv.slice(2);
fileNames.forEach(fileName => {
    // Parse a file
    let sourceFile = ts.createSourceFile(fileName, fs_1.readFileSync(fileName).toString(), ts.ScriptTarget.ES6, /*setParentNodes */ true);
    // delint it
    delint(sourceFile);
});
//# sourceMappingURL=../../src/sourcemap/typescript/walker.js.map